# tab_switcher

[![pub package](https://img.shields.io/pub/v/tab_switcher.svg)](https://pub.dartlang.org/packages/tab_switcher)

Framework for building apps with fullscreen tab based UI in a way Chrome for Android is built.

Building a smartphone IDE? Developing yet another internet browser? Designing a very complex app with dozens of screens that need to be shown simultaneously? 

Then you came to the right place. Wrap your screens in tabs to offer rich multitasking experience to your users!

## Screenshot
<img src="https://user-images.githubusercontent.com/13202642/168449701-0deec42d-9c54-4581-a56e-eaff855b97ea.png#gh-light-mode-only" width="450" align="center">
<img src="https://user-images.githubusercontent.com/13202642/168449705-5b86a383-0dbb-477e-bb3c-f409327d7274.png#gh-dark-mode-only" width="450" align="center">

## Features
- [x] Gesture support
* Swipe header horizontally to switch between tabs
* Swipe header down to open tab grid
* Swipe minimized tab to close it
- [x] Tab content is captured to image when tab is minimized, so background tabs do not waste resources on rebuilding
- [x] Uses colors specified in `MaterialApp`'s `ThemeData`. Tuned to look good out of the box
- [x] Customizable: replace everything with custom `Widget`
- [x] Comes with tab count button out of the box
- [ ] Preserving tab state is straightforward
- [ ] Everything is smoothly animated
- [ ] Landscape oprientation is supported

## More screenshots & GIFs

TBD

## Web demo

TBD

## Usage

TBD
